
/*
 * 
 * $Log: xnl.h,v $
 * Revision 1.13  1993/06/16  14:06:51  wade
 * set version number to 3.4
 *
 * Revision 1.12  1993/06/12  11:23:47  browne
 * *** empty log message ***
 *
 * Revision 1.11  1993/05/25  16:16:46  browne
 * added widget for conference database
 *
 * Revision 1.10  1993/04/28  18:42:09  wade
 * set version 3.4
 *
 * Revision 1.9  1993/04/21  20:38:15  wade
 * *** empty log message ***
 *
 * Revision 1.8  1993/03/06  23:17:48  larose
 * added biblio_file for bibliographic buttons..
 *
 * Revision 1.7  1993/02/19  22:49:50  wade
 * added finger demo support
 *
 * Revision 1.6  1993/02/02  00:40:50  larose
 * added PAPERS_FILE so we can bibliographic reference to performance
 * papers which are cross-referenced around places..
 *
 * -brian
 *
 * Revision 1.5  1992/12/15  21:43:56  wade
 * *** empty log message ***
 *
 * Revision 1.4  1992/12/15  20:01:20  wade
 * converting conhelp to text
 *
 * Revision 1.3  1992/12/14  17:01:56  wade
 * set version to 3.3
 *
 * Revision 1.2  1992/12/05  17:27:42  larose
 * added rcs logging
 *
 *
 */


#define XNL_MAJOR_VER	3
#define XNL_MINOR_VER	4
#define HOT_FLASH    "xnetlib/hotflash_3.4"

#include <stdio.h>
#include <sys/ioctl.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xaw/AsciiText.h>
#include "UtkasciiText.h"
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SmeBSB.h>
#include "GasGauge.h"


#include <X11/Shell.h>

#include "patchlevel.h"

Widget statusLabel, fastHelpLabel, infoLabel;

#define SURFER_ADDR       "*netlib.ornl.gov"        /* surfer */

#define STATUS_DEFAULT    "Xnetlib 3.4"
#define INFO_DEFAULT    "network status window"

#define XNL_WIDTH   700
#define XNL_HEIGHT  600
#define MAXLINE 2550
#define XNL_MAXHEIGHT  9999
#define XNL_MINHEIGHT  1
#define DEFAULT_XNL_PATH    "/bone/homes/wade/xnlData"
#define DEFAULT_XNL_DOWNLOAD_PATH    "/bone/homes/wade/xnlFiles"
#define XNL_PATH    app_resources.xnlPath
#define XNL_DOWNLOAD_PATH    app_resources.xnlDownloadPath
#define DIR_MODE    0000755
#define PUB_DIR_MODE    0000777
#define DEP_CHECK    app_resources.depCheck
#define SHOW_WHO_INFO    app_resources.showWhoInfo
#define SHOW_REC_ANYWAY    app_resources.showReceiveAnyway
#define CONFIRM_QUIT    app_resources.confirmQuit
#define PUBDATA app_resources.publicData
#define DONT_WARP app_resources.dontWarp
#define EMAIL_ADDRESS app_resources.email
#define PRINT_COMMAND app_resources.whoPrintCommand
#define FINGER_DEMO app_resources.fingerDemo


char *emailAddress;



#define HOST_FILE app_resources.hostFile
#define IDX_LIFE app_resources.indexLifetime

#define SEC_PER_DAY  86400
#define SEC_PER_HOUR 3600

#define INDEX_FILE   "master/readme"
#define LIB_FILE    "master/index"
#define MOTD_FILE    "master/motd"
#define CLASS_FILE    "master/class.index"
#define SITE_ICON    "master/site.icon"



#define WHO_HEADER   "Na-Net White Pages"
#define UPDATE_HEADER   "New Items and Directory Update"
#define HELP_HEADER   "Helpful Information"
#define INDEX_HEADER   "General Index"
#define LIB_HEADER   "Select Library"
#define LIBSEL_HEADER   "Select Files"
#define RECV_HEADER   "Download Files"
#define CLASS_HEADER   "Select Classification"
#define KEYWORD_HEADER   "Enter Search Criteria"
#define DATABASE_HEADER   "Enter Search Criteria"
#define MOTD_HEADER   "Message of the Day"
#define REXEC_HEADER   "Remote Execution Services"

#define NORMALHELP    STATUS_DEFAULT
#define GOBACKHELP    "move up to previous directory"
#define INDEXHELP    "display index"
#define LIBRARYHELP    "display top level library listing"
#define HELPHELP    "display help file"
#define RECVHELP    "enter Download mode"
#define CLASSHELP    "view classifications"
#define KEYHELP        "search the index files"
#define DATABASEHELP        "look at conference database"
#define WHOHELP        "query the Na-Net White Pages directory"
#define UPDATEHELP    "load new file indices"
#define EXITHELP    "exit Xnetlib"
#define MOTDHELP    "display current message of the day"
#define CONTEXTHELPHELP    "help popup for current mode"
#define NEWWINHELP    "show current mode's text in new window"
#define REXECHELP    "use remote execution services"

Dimension norm_wide;
Dimension norm_high;

typedef struct _AppResources {
    String whoEntrySep;
    String whoPrintCommand;
    String xnlPath;
    String xnlDownloadPath;
    Pixel greenCol;
    Pixel redCol;
    Pixel yellowCol;
    String hostFile;
    String email;
    Boolean fingerDemo;
    Boolean depCheck;
    Boolean showWhoInfo;
    Boolean showReceiveAnyway;
    Boolean confirmQuit;
    Boolean publicData;
    Boolean dontWarp;
    int indexLifetime;
} AppResources;

AppResources app_resources;

Boolean MONO; /* set in main */

int Num_to_receive; /* number of files marked to receive    */
int Mode, Mode_desired, Mode_last;    /* what mode are we in; library, who,..    */
int LibOrClass;
int LastClassItem;
int Curr_list_index, Last_list_index;

String downloadPath;

String List[10240];
String FileList[10240];

String HostList[10240];
char KeywordServer[10240], WhoisServer[10240];
char DatabaseServer[10240];

char currentLib[255];

char username[255], Home[255];

String mainClassList[10240];
String mainclassFileList[10240];
String ClassList[10240];
String classFileList[10240];

String DownloadList[10240];

char **server_list;
int Many_servers;
int topdirServerList[10240];
String topdirList[10240];

extern Widget nextdescButton, descrecvButton;


XtAppContext app_con;

FILE *sendRequest();

void Destroy_form();

void PopupHostListMenu();

Widget toplevel;
Widget topPane, buttonForm, topView;
Widget gasgauge;
Widget exitButton, whoButton, classificationButton, libraryButton,
        helpButton, indexButton, indexMenu, keywordButton, receiveButton,
		databaseButton,
		printButton, contextHelpButton, newWinButton, rexecButton,
        gobackButton, updateButton, motdButton, motdMenu;

Widget helpPic; /* widget containing the help bitmap, or NULL */

Widget currentDisplayText; /* which text widget to print */


#ifdef STUB
Widget stubButton, stubMenu, *stubPop;
int Popdown_stub(), Popup_stub();
#define STUB_FILE    "master/stub"
#define STUBHELP    "change help line in xnl.h"
#define STUB_HEADER   "Change Header in Xnl.h"
int currentUpStub;
#endif
#ifdef PERFORMANCE
Widget performanceButton, performanceMenu, perfForm;
int Popdown_performance(), Popup_performance();
#define PERFORMANCE_FILE    "master/performance"
#define PERFORMANCEHELP    "Enter performance database mode"
#define PERFORMANCE_HEADER   "Performance Database Server"
#define RANK_FILE    "performance/rank/index"
#define PAPERS_FILE    "performance/papers/index"
#define BIBLIO_FILE    "performance/biblio/index"
int currentUpPerformance;
#endif


int currentUpIndex, currentUpMotd;

Widget helpPop, *indexPop, *motdPop;
Widget libraryPop, libraryList;
Widget libSelForm;
Widget classPop, classList;
Widget classSelPop;
Widget keywordForm, whoForm, receiveForm, receiveViewport, updateForm;
Widget databaseForm, databaseDisplayText;
Widget keywordDisplayText;
Widget rexecForm, rexecDisplayText;
Widget whoDisplayText;


Pixmap togglePix, subdirPix, checkPix;

#define MODE_NORMAL        0
#define MODE_RECEIVE       1
#define MODE_CLASSIFICATION    2
#define MODE_KEYWORD       3
#define MODE_WHO           4
#define MODE_HELP          5
#define MODE_INDEX         6
#define MODE_LIBRARY       7
#define MODE_LIBSELECT     8
#define MODE_CLASSSELECT   9
#define MODE_UPDATE       10
#define MODE_QUIT         11
#define MODE_MOTD         12
#ifdef STUB
#define MODE_STUB         13
#endif
#ifdef PERFORMANCE
#define MODE_PERFORMANCE  14
#endif
#define MODE_REXEC        15
#define MODE_DATABASE        16
#define MAX_MODE          20

int Popdown_receive(),
    Popdown_classification(),
    Popdown_keyword(),
    Popdown_database(),
    Popdown_who(),
    Popdown_help(),
    Popdown_index(),
    Popdown_library(),
    Popdown_libSelect(),
    Popdown_classSelect(),
    Popdown_update(),
    Popdown_motd(),
    Popup_rexec(),
    Popdown_rexec(),
    Popup_motd(),
    Popup_update(),
    Popup_receive(),
    Popup_classification(),
    Popup_keyword(),
    Popup_database(),
    Popup_who(),
    Popup_help(),
    Popup_index(),
    Popup_library(),
    Popup_libSelect(),
    Popup_classSelect();

String con_help[MAX_MODE+1];

void do_who();
void do_keyword();
void do_database();
void do_rexec();
void do_receive();

#ifdef PERFORMANCE
void do_psearch();
void do_compsearch();
#endif


int file_is_subdir();
Boolean file_in_list();
void toggleFile();
void commtoggleFile();

/* colors for set_status */
#define GREEN    0
#define RED        1
#define YELLOW    2
#define WHITE    3
#define BLACK    4

#ifndef MAX
#define MAX(a,b) \
    (((a) > (b)) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) \
    (((a) < (b)) ? (a) : (b))
#endif

Cursor busyCursor, normalCursor, xtermCursor;
#define CURSOR_INIT        1
#define CURSOR_BUSY        2
#define CURSOR_NORMAL    3
#define CURSOR_NORMAL_XTERM    4


/* ardent tmpnam fix from  Nelson H.F. Beebe (beebe@math.utah.edu) */
#if ardent
/* Work around for buggy tmpnam(); it returns something like
   /usr/tmpaaaa02223 instead of /usr/tmp/aaaa02223 */
extern char     *(tempnam)(char *,char *);
#define tmpnam(x) (char*)tempnam("/usr/tmp", "xnl")
#endif

#if defined(sequent)
#define tmpnam(x) (char*)mktemp("/tmp/xnl_XXXXXX")
#endif


unsigned long what_time();
char *age2s();

#define swrite(s, str)  write(s, str, strlen(str))

/*LINTLIBRARY*/

